#include "DEGroupBox.H"

DGroupBox::DGroupBox(QPopupMenu* view = 0, int index = 0, QWidget * parent = 0, const char * name = 0 ):QGroupBox(parent, name) {
  _son = NULL;
  _grandson = NULL;
  _view = view;
  _index = index;
  _name = new char[strlen(name) + 1];
  strcpy(_name,name);
  markedDeleted = 0;
}

char* DGroupBox::getName() {
  return _name;
}

int DGroupBox::getMarkedDeleted() {
  return markedDeleted;
}

void DGroupBox::markDeleted() {
  markedDeleted = 1;
}

DGroupBox::~DGroupBox() {
  delete[] _name;
}

void DGroupBox::setGrandson(DPaintWindow * gs)
{
  _grandson = gs;
}

void DGroupBox::setSon(DScrollWidget* son)
{
  _son = son;
}

void DGroupBox::resizeEvent ( QResizeEvent * e )
{
  QGroupBox::resizeEvent(e);
  if (_son) {
    _son->setGeometry(5, 15, size().width()-10, size().height()-20);
    _son->repaint();
  }
  if (_grandson) {
    _grandson->setGeometry(0,0,int(ceil((_son->size().width()-4)*_grandson->getZoomFactor())), int(ceil((_son->size().height()-4)*_grandson->getZoomFactor())));
    _grandson->repaint();
  }
}

void DGroupBox::redoGeometryCalculations()
{
  if (_son) {
    _son->setGeometry(5, 15, size().width()-10, size().height()-20);
    _son->repaint();
  }
  if (_grandson) { 
    int temp1 = int(ceil((_son->size().width()-4)*_grandson->getZoomFactor()));
    int temp2 = int(ceil((_son->size().height()-4)*_grandson->getZoomFactor()));
    //I have no idea why I have to have this line in here twice, but if I don't and then do zoom in, scroll all the way to the right, and then zoom out, I get gray space on the leftt. I have no idea why repeating the following line twice fixes this problem - probably some ideosyncracy with QT.
    _grandson->setGeometry(0,0,temp1, temp2);
    _grandson->setGeometry(0,0,temp1, temp2);
    _grandson->repaint();
  }
}

void DGroupBox::moveScrollBars(float ratio_x, float ratio_y) {
  _son->horizontalScrollBar()->setValue(int(_son->horizontalScrollBar()->maxValue() * ratio_x));
  _son->verticalScrollBar()->setValue(int(_son->verticalScrollBar()->maxValue() * ratio_y));
}

void DGroupBox::setViewVals(QPopupMenu* view, int index)
{
  _view = view;
  _index = index;
}

bool DGroupBox::close( bool alsoDelete ) {
  if (_view) {
    if (strcmp(_name,"ISOLATION")==0) {
      _view->removeItem(_index);
      markedDeleted = 1;
    }
    else if (_view->isItemChecked(_index)) 
      _view->setItemChecked(_index, false);
    return QWidget::close(alsoDelete);
  }
}
