//////////////////////////////////////////////////////////////////////////////
//                                                                          
//  NAME: Joon-Suk Lee (jl)
//  FILE: PCPreCond.C
//  PROJ: COKO
//  DATE: 10/9/96                                                              
//
// SYNOPSIS
// Class definitions for CPreCond.
//  
//////////////////////////////////////////////////////////////////////////////

#ifndef _PCMULMATCHSTMT_C_
#define _PCMULMATCHSTMT_C_


#include "PCPreCond.H"
#include "CGlobals.H"

//////////////////////////////////////////////////////////////////////////////
//                                                                          
// Function Name: CPreCond
// Parameters:	(char* a ... )
//
// Constructor.
//         								    
//////////////////////////////////////////////////////////////////////////////

CPreCond::CPreCond(char* a ... )
{
  va_list ap;
  va_start (ap,a);
 
  _condList = new CondList();

  for(;;)
	{
	  CCond* p = va_arg(ap, CCond*);
	  if (p == NULL) 
		break;
	  else 
		_condList->insert(p);
	}
  va_end(ap);
}

//////////////////////////////////////////////////////////////////////////////
//                                                                          
// Function Name: ~CPreCond
// Parameters:	(void)
//
// Destructor.
//         								    
//////////////////////////////////////////////////////////////////////////////

CPreCond::~CPreCond(void)
{
  if (_condList) { delete _condList; _condList = NULL; }

}

//////////////////////////////////////////////////////////////////////////////
//                                                                          
// Function Name: Exec
// Parameters:	(CState*)
//
// What to do when executed.
//         								    
//////////////////////////////////////////////////////////////////////////////

CState* CPreCond::Exec(CState * s, NonType* nt)
{     
  _condList->initIterator();
  CCond *current = NULL;

  while ( current = _condList->getValue() ){
    s = current->Exec(s);

    if (!s->ISuccess() )
      break;
  }
  
  return s;  
}

#endif

