//////////////////////////////////////////////////////////////////////////////
//                                                                          
//  NAME: Marina Zlatkina
//  FILE: NotProperty.H
//  PROJ: COKO
//  DATE: 8/2001                                                            
//
// SYNOPSIS
//  Represents the negation of a property.
//  
//////////////////////////////////////////////////////////////////////////////
#ifndef _NOTPROPERTY_H
#define _NOTPROPERTY_H

#include "Property.H"
#include "PCState.H"
#include "NonTypeArgs.H"

class NotProperty: public Property{

private:
  Property *prop;
  // the property which we want negated

public:
  NotProperty( Property *p ): prop(p){};
  // constructor

  NonTypeArgs * isTrue( CState *, NonTypeArgs *a);
  // returns true if the isTrue method of prop returns false, and vice versa
};

#endif
