//////////////////////////////////////////////////////////////////////////////
//                                                                          
//  NAME: Marina Zlatkina
//  FILE: SchemaProperty.H
//  PROJ: COKO
//  DATE: 8/2001                                                            
//
// SYNOPSIS
//  Class to represent a fact. The isTrue method determine if this fact is
//  present in the Schema file.
//  
//////////////////////////////////////////////////////////////////////////////
#ifndef _SCHEMAPROPERTY_H
#define _SCHEMAPROPERTY_H

#include "Property.H"
#include "NonTypeArgs.H"
#include <string>

class CState;
class NonType;

class SchemaProperty: public Property{
public:
  SchemaProperty(string,NonTypeArgs *);
  // constructor

  virtual NonTypeArgs * isTrue(CState *, NonTypeArgs *);
  // determines if the fact represented by this object is in the Schema file

private:
  string key;
  // stores the fact name

  NonTypeArgs *tree;
  // the arguments to the fact
};

#endif
