
/* -*-Mode:c++-*- */

//////////////////////////////////////////////////////////////////////////////
//                                                                          
//  NAME: Mitch Cherniack (mfc)
//        Xiaoyu Wang (wangxy)
//  FILE: KOTDollar.C 
//  PROJ: COKO, KOLA
//  DATE: 9/00		                                                    
//
//////////////////////////////////////////////////////////////////////////////

#include "KOTDollar.H"
extern "C" { int atio(const char *s); }
  
//////////////////////////////////////////////////////////////////////////////
//
// Function Name:  TDollar
// Parameters: (TagExp* te)
//
// Constructor.
//
// needs refine later...
//
/////////////////////////////////////////////////////////////////////////////

TDollar::TDollar(TagExp* te):TagExp(TAGEXP_DOLLAR, "$" )
{
    one = te;
    variableNum = 0;
}

//////////////////////////////////////////////////////////////////////////////
//
// Function Name:  TDollar
// Parameters:(TDollar& other)
//
// Copy Constructor
//
/////////////////////////////////////////////////////////////////////////////

TDollar::TDollar(const TDollar& other):TagExp((TagExp &)other)
{
    one = other.One()->Copy();
    variableNum = other.getVariableNum();
}

/////////////////////////////////////////////////////////////////////////////
//
// Function Name: ~TDollar
// Parameters: ()
//
// Destructor
//
/////////////////////////////////////////////////////////////////////////////

TDollar::~TDollar()
{
  delete one;
}

/////////////////////////////////////////////////////////////////////////////
//
// Function Name: Copy
// Parameters: ()
//
// return the copy of this tagexp
//
/////////////////////////////////////////////////////////////////////////////

TagExp* TDollar::Copy() const
{
  TDollar* temp = new TDollar (*this);
  temp->setVariableNum(variableNum);
  return temp;
}

/////////////////////////////////////////////////////////////////////////////
//
// Function Name: deepeq
// Parameters: (NonType *)
//
// does nothing 
//
/////////////////////////////////////////////////////////////////////////////

int TDollar::deepeq(NonType* other)
{
  return T;
}

////////////////////////////////////////////////////////////////////////////
//
// Function Name: Myname
// Parameters: ()
//
// return a union type, NameUnion.
// since NonType has 6 different sub-classes....
//
////////////////////////////////////////////////////////////////////////////

NameUnion* TDollar::Myname()
{
  return NULL;
}

/////////////////////////////////////////////////////////////////////////////
//
// Function Name:  nextChild
// Parameters: ()
//
// Return "currChild++"th child.
// When currChild is equal to the number of children
// (when currChild is the last child), it returns NULL.
//
/////////////////////////////////////////////////////////////////////////////

NonType* TDollar::nextChild()
{
  if(currChild == 0)
    {
      currChild++;
      return one;
      }
  else  return NULL;
}

/////////////////////////////////////////////////////////////////////////////
//
// Function Name: representation
// Parameters: ()
//
// "DOLLAR" + one -> representation ()
//
/////////////////////////////////////////////////////////////////////////////

char * TDollar::representation()
{
  char *pr = one->representation();
  char *res = new char[strlen(pr)+strlen("$ ")+1];
    sprintf(res, "$ %s", pr);
    delete [] pr;
    return res;
}


////////////////////////////////////////////////////////////////////////////
//
// Function Name: transform
// Parameters: (CState*)
//
// Return corresponding NonType object.
//
// Now it does nothing just return itself 
//
////////////////////////////////////////////////////////////////////////////

NonType* TDollar::transform(CState* s)
{
    return this;
}

////////////////////////////////////////////////////////////////////////////
//
// Function Name: compares
// Parameters: (NonType*, CState*)
//
// compare two trees
//
////////////////////////////////////////////////////////////////////////////

int TDollar::compares(NonType* nt, CState* a)
{
    return T;
}

//////////////////////////////////////////////////////////////////////////
//
// Function Name: compareSTM
// Parameter: (NonType*, CState*)
//
// Check for match between two NonType tree...
//
// Does nothing now, just return T, 
//
//////////////////////////////////////////////////////////////////////////

int TDollar::compareSTM(NonType* nt, CState* a)
{
    return T;
}

//////////////////////////////////////////////////////////////////////////
//
// Function Name: setDEPnInvDEP
// Parameter:  (char*, CState*)
//
// set dependency list and....
//
///////////////////////////////////////////////////////////////////////////

void TDollar::setDEPnInvDEP(char *vn, CState* s)
{
  one->setDEPnInvDEP(vn, s);
}

///////////////////////////////////////////////////////////////////////////
//
// Function Name: undoSetInvDEP
//
// Parameters: (char *, CState*)
//
// Undo the changes.
//
///////////////////////////////////////////////////////////////////////////

void TDollar::undoSetInvDEP(char* vn, CState* s)
{
    one->undoSetInvDEP(vn, s);
}

///////////////////////////////////////////////////////////////////////////
//
// Function Name: replaceChild
// Parameters: (NonType*, int)
//
// Replace a child of a given tree..
//
///////////////////////////////////////////////////////////////////////////

void TDollar::replaceChild(NonType* child, int which_child)
{
    if(which_child == 1)
         setOne(child);
}


///////////////////////////////////////////////////////////////////////////
//
// Function Name: prolog
// Parameters:()
//
// Does nothing, return NULL
//
//////////////////////////////////////////////////////////////////////////

char* TDollar::prolog()
{
    return NULL;
}

#ifdef _PROLOG_
///////////////////////////////////////////////////////////////////////////
//
// Function Name: sp_prolog
// Parameters:()
//
// Does nothing, return NULL
//
///////////////////////////////////////////////////////////////////////////

SP_term_ref TDollar::sp_prolog()
{
    return NULL;
}
#endif //_PROLOG_

