
/* -*-Mode:c++-*- */

//////////////////////////////////////////////////////////////////////////////
//
// NAME: Mitch Cherniack (mfc@cs.brown.edu)
//	 Xiaoyu Wang (wangxy)
// FILE: KOTagExpList.C
// PROJ: COKO Compiler, KOLA Parcer
// DATE: 9/00 
//
//////////////////////////////////////////////////////////////////////////////

#include "KOTagExpList.H"

//////////////////////////////////////////////////////////////////////////////
//                                                                          
// Function Name: TagExpList
// Parameters:	()
//
//  Constructor.
//         								    
//////////////////////////////////////////////////////////////////////////////

TagExpList::TagExpList ()
{
  first = NULL;
  last = NULL;
}

//////////////////////////////////////////////////////////////////////////////
//                                                                          
// Function Name: TagExpList
// Parameters:	(const TagExpList&)
//
//  Copy Constructor.
//         								    
//////////////////////////////////////////////////////////////////////////////

TagExpList::TagExpList (const TagExpList & other)
{
  if(other.First() == NULL){
    first = NULL;
    last = NULL;
  } else if((other.First())->Next() == NULL){
    first = new TagExpLink(*(other.First()));
    last = first;
  } else{
    first = new TagExpLink(*(other.First()));
    TagExpLink *ptr = first->Next();
    TagExpLink *pptr = first;
    while(ptr != NULL){
      pptr = ptr;
      ptr = ptr->Next();
    };
    last = pptr;
  }
}

//////////////////////////////////////////////////////////////////////////////
//                                                                          
// Function Name: ~TagExpList
// Parameters:	()
//
//  Destructor.
//         								    
//////////////////////////////////////////////////////////////////////////////

TagExpList::~TagExpList ()
{
  delete first;
}

//////////////////////////////////////////////////////////////////////////////
//
// Function Name: Copy
// Parameters: ()
//
// Copy
//
//////////////////////////////////////////////////////////////////////////////

TagExpList *TagExpList::Copy() const
{
  TagExpList* temp = new TagExpList (*this);
  return temp;
}


//////////////////////////////////////////////////////////////////////////////
//                                                                          
// Function Name:  insert
// Parameters:	(TagExp*)
//
// Does nothing now
//         								    
//////////////////////////////////////////////////////////////////////////////

TagExpList *TagExpList::insert (TagExp* te)
{
  TagExpLink* tl = new TagExpLink(te);
  if(first == NULL){
    first = tl;
    last = tl;
  }else{
    last->Next(tl);
    last = tl;
  }
  return this;
}

//////////////////////////////////////////////////////////////////////////////
//
// Function name: listeq
// Parameters: (TagExpList*)
//
// compare if the two TagExpList Equal. Does nothing here. 
//
//////////////////////////////////////////////////////////////////////////////

int TagExpList::listeq(TagExpList* otherList)
{
  return T;
}

///////////////////////////////////////////////////////////////////////////////
//
// Function Name: representation
// Parameters: ()
//
///////////////////////////////////////////////////////////////////////////////

char *TagExpList::representation()
{
  char* oldres;
  char* res;
  
  TagExpLink* ptr = first;
  if(ptr != NULL){
    char* tr = ptr->representation();
    res = new char [strlen(tr)+1];
    sprintf(res, "%s", tr);
    delete[] tr;
    ptr = ptr->Next();
    
    while(ptr != NULL){
      char *tr = ptr->representation();
      oldres = res;
      res = new char[strlen(oldres)+strlen(tr)+strlen(", ")+1];
      sprintf(res, "%s, %s", oldres, tr);
      delete[] tr;
      delete[] oldres;
      ptr = ptr->Next();
    };
  }else{
    res = new char[1];
    sprintf(res, "");
  }
  return res;
}


/////////////////////////////////////////////////////////////////////////////
//
// Function name: prolog
// parameters: ()
//
//
/////////////////////////////////////////////////////////////////////////////

char *TagExpList::prolog(){
  char * res;
  res = new char[strlen("PROLOG")+1];
  sprintf(res, "PROLOG");
  
  return res;
}

//////////////////////////////////////////////////////////////////////////////
//
// Function name: sql 
// parameters: ()
//
//
//////////////////////////////////////////////////////////////////////////////

char *TagExpList::sql()
{
  char *res = new char[strlen("SQL")+1];
  sprintf(res, "SQL");
  return res;
}

/////////////////////////////////////////////////////////////////////////////
//
// Function name: oql
// Parameters: ()
//
//////////////////////////////////////////////////////////////////////////////

char *TagExpList::oql()
{
  char *res = new char[strlen("OQL")+1];
  sprintf(res, "OQL");
  return res;
}

#ifdef _PROLOG_
//////////////////////////////////////////////////////////////////////////////
//
// Function Name:  sp_prolog
// Parameters:	()
//
// Since C/C++ functions only have indirect access to Prolog terms 
// via SP_term_refs, we need to convert kola tree to SP_term_refs.
// Converted kola tree will get passed to prolog runtime system.
//
// See the Sicstus prolog version 3#6 manual for more detailed info on
// the usage of SP_term_refs and other prolog supplied methods.
//
//////////////////////////////////////////////////////////////////////////////

SP_term_ref TagExpList::sp_prolog ()
{
  // fix this!
  return NULL;
}
#endif // _PROLOG_

///////////////////////////////////////////////////////////////////////////////
//
// Function Name: tagexplist
// Parameters: ()
//
///////////////////////////////////////////////////////////////////////////////

TagExpList* TagExpList::tagexplist()
{
  if(first == NULL)
    return new TagExpList();
  else
    return first->tagexplist(new TagExpList());
}
