
/* -*-Mode:c++-*- */

//////////////////////////////////////////////////////////////////////////////
//                                                                          
//  NAME: Mitch Cherniack (mfc)
//        Xiaoyu Wang (wangxy)
//  FILE: KOTagExpList.H 
//  PROJ: COKO, KOLA
//  DATE: 9/00		                                                    
//
// SYNOPSIS
//  List of objects that denote members of a set
//  in a KOLA tree.
//
//////////////////////////////////////////////////////////////////////////////

#ifndef KOLA_TAGEXPLIST_HEADER
#define KOLA_TAGEXPLIST_HEADER 

#include "KGlobals.H"
#include "KOTagExpLink.H"
#include "PCState.H"
#include "KONameUnion.H"
#include "KOTagExp.H"

#include <string.h>

class TagExpList
{
public:
  TagExpList ();
  //constructor construct an empty list(set)
  // first = null, last = null;
  
  TagExpList (const TagExpList  &other);
  //  Copy Constructor.  

  ~TagExpList ();
  //  Destructor.  
  
  TagExpList* Copy() const;

  TagExpLink *First() const { return first; }
  
  TagExpLink * Last() const { return last; }
  
  TagExpList* insert (TagExp* o);
  //  insert object into set:

  char *representation();
	
  int listeq(TagExpList* otherlink);
  // compare two list, 
  // every element in the first list should be in the second list
  // and vice verse
  // added for deepeq()....

  char * prolog();
  // return string representation in prolog form

  char * oql();
  // Ruturn the OQL string equivalent of this object
  
  char * sql();
  // Return the sql string equivalent of this object

  TagExpList* tagexplist();
  // Symbolic simplification of all the tagexps in the list.

#ifdef _PROLOG_
  SP_term_ref sp_prolog ();
  // convert kola tree into prolog term and return it.
#endif // _PROLOG_ 
  
protected:
  TagExpLink* first;
  // what is the first tagexp in this list? (NULL 
  // if the list (and hence set) is empty)

  TagExpLink* last;
  // what is the last object in this list(set)? (null
  // if the list (and hence set) is empty.


};

# endif



