/*
 * Copyright 1994, Brown University, Providence, RI
 *
 * Permission to use and modify this software and its documentation for
 * any purpose other than its incorporation into a commercial product is
 * hereby granted without fee.  Permission to copy and distribute this
 * software and its documentation only for non-commercial use is also
 * granted without fee, provided, however, that the above copyright notice
 * appear in all copies, that both that copyright notice and this permission
 * notice appear in supporting documentation, that the name of Brown
 * University not be used in advertising or publicity pertaining to
 * distribution of the software without specific, written prior permission,
 * and that the person doing the distribution notify Brown University of
 * such distributions outside of his or her organization. Brown University
 * makes no representations about the suitability of this software for
 * any purpose.  It is provided "as is" without express or implied warranty.
 * Brown University requests notification of any modifications to this
 * software or its documentation.
 *
 * Send the following redistribution information:
 *
 *      Name:
 *      Organization:
 *      Address (postal and/or electronic):
 *
 * To:
 *      Software Librarian
 *      Computer Science Department, Box 1910
 *      Brown University
 *      Providence, RI 02912
 *
 *              or
 *
 *      brusd@cs.brown.edu
 *
 * We will acknowledge all electronic notifications.
 */

/* -*-Mode:c++-*- */

//////////////////////////////////////////////////////////////////////////////
//
// NAME: Joon S. Lee (jl@cs.brown.edu)
// FILE: TYTFlt.C
// DATE: 8/97
//
//////////////////////////////////////////////////////////////////////////////

#include "TYTFlt.H"
//////////////////////////////////////////////////////////////////////////////
//                                                                          
// Function Name:  TFlt
// Parameters:	()							  
//
//  Constructor
//         								    
//////////////////////////////////////////////////////////////////////////////

TFlt::TFlt ()
{
  myname = TYPE_FLT;
}


//////////////////////////////////////////////////////////////////////////////
//                                                                          
// Function Name:  TFlt
// Parameters:	(TFlt& other)							  
//
//  Copy Constructor
//         								    
//////////////////////////////////////////////////////////////////////////////

TFlt::TFlt (TFlt& other)
{

  myname = TYPE_FLT;

}


//////////////////////////////////////////////////////////////////////////////
//                                                                          
// Function Name:  ~TFlt
// Parameters:	()							  
//
//  Destructor
//         								    
//////////////////////////////////////////////////////////////////////////////

TFlt::~TFlt ()
{
}


//////////////////////////////////////////////////////////////////////////////
//                                                                          
// Function Name:  representation
// Parameters:	()							  
//
//  return "FLOAT"
//         								    
//////////////////////////////////////////////////////////////////////////////

char* TFlt::representation ()
{

    char* res = new char [strlen ("REAL") + 1];
    sprintf (res, "%s", "REAL");
    return res;
}



//////////////////////////////////////////////////////////////////////////////
//                                                                          
// Function Name:  Copy
// Parameters:	()							  
//
//  return copy of this as TObj*
//         								    
//////////////////////////////////////////////////////////////////////////////

TObj* TFlt::Copy ()
{

    return new TFlt (*this);

}


//////////////////////////////////////////////////////////////////////////////
//                                                                          
// Function Name:  prolog
// Parameters:	()							  
//
//  return "FLOAT"
//         								    
//////////////////////////////////////////////////////////////////////////////

char* TFlt::prolog ()
{

    char* res = new char [strlen ("tflt") + 1];
    sprintf (res, "tflt");
    return res;
}

#ifdef _PROLOG_
//////////////////////////////////////////////////////////////////////////////
//
// Function Name:  sp_prolog
// Parameters:	()
//
// Since C/C++ functions only have indirect access to Prolog terms 
// via SP_term_refs, we need to convert kola tree to SP_term_refs.
// Converted kola tree will get passed to prolog runtime system.
//
// See the Sicstus prolog version 3#6 manual for more detailed info on
// the usage of SP_term_refs and other prolog supplied methods.
//
//////////////////////////////////////////////////////////////////////////////

SP_term_ref TFlt::sp_prolog ()
{
  SP_term_ref res = SP_new_term_ref();
  SP_put_string(res,"tflt");
  return res;
}
#endif // _PROLOG_
