/* -*-Mode:c++-*- */

/*
 * Copyright 1994, Brown University, Providence, RI
 *
 * Permission to use and modify this software and its documentation for
 * any purpose other than its incorporation into a commercial product is
 * hereby granted without fee.  Permission to copy and distribute this
 * software and its documentation only for non-commercial use is also
 * granted without fee, provided, however, that the above copyright notice
 * appear in all copies, that both that copyright notice and this permission
 * notice appear in supporting documentation, that the name of Brown
 * University not be used in advertising or publicity pertaining to
 * distribution of the software without specific, written prior permission,
 * and that the person doing the distribution notify Brown University of
 * such distributions outside of his or her organization. Brown University
 * makes no representations about the suitability of this software for
 * any purpose.  It is provided "as is" without express or implied warranty.
 * Brown University requests notification of any modifications to this
 * software or its documentation.
 *
 * Send the following redistribution information:
 *
 *	Name:
 *	Organization:
 *	Address (postal and/or electronic):
 *
 * To:
 *	Software Librarian
 *	Computer Science Department, Box 1910
 *	Brown University
 *	Providence, RI 02912
 *
 *		or
 *
 *	brusd@cs.brown.edu
 *
 * We will acknowledge all electronic notifications.
 */


/* -*-Mode:c++-*- */

//////////////////////////////////////////////////////////////////////////////
//
// NAME: Mitch Cherniack (mfc@cs.brown.edu)
// FILE: QLParser.C
// PROJ: QLite -> KOLA Translator
// DATE: 7/98
//
//////////////////////////////////////////////////////////////////////////////

#include "QLParser.H"

extern FILE *QLin;
extern NonType *result;
extern int lineno3;
extern int QLparse ();


//////////////////////////////////////////////////////////////////////////////
//                                                                          
// Function Name:  QLParser
// Parameters: char *q
// Returns:
//
// Contructor.
//                                                                          
//////////////////////////////////////////////////////////////////////////////

// Constructor. Give the query to parse as input.

QLParser::QLParser (char *q)
{
  inp = NULL;
  setInput (q);
}


//////////////////////////////////////////////////////////////////////////////
//                                                                          
// Function Name:  ~QLParser
// Parameters:                                                            
// Returns:
//
// Destructor.
//                                                                          
//////////////////////////////////////////////////////////////////////////////

QLParser::~QLParser ()  {
  if (inp != NULL) fclose (inp); 
}


//////////////////////////////////////////////////////////////////////////////
//                                                                          
// Function Name:  parse
// Parameters:                                                            
// Returns:        NonType *
//
// Parse the query contained in the current file, inp, and return the
// resulting KOLA tree.
//                                                                          
//////////////////////////////////////////////////////////////////////////////

NonType* QLParser::parse ()
{
  if (inp != NULL) {
    int res = 0;
    QLin = inp;
    if (!QLparse ()) {
      return result;
    } else {
      cerr << "\nQLParser: failed due to syntax error\n\n";
      return NULL;
    }

  } else  {
    cerr << "QLParser: Input query not found \n\n";
    return NULL;
  }
}


//////////////////////////////////////////////////////////////////////////////
//                                                                          
// Function Name:  setInput
// Parameters:     char *
// Returns:
//
// Change the file to parse by this to f.
//                                                                          
//////////////////////////////////////////////////////////////////////////////

void
QLParser::setInput (char *f)  {

  lineno3 = 1;
  if (inp != NULL) fclose (inp);

  inp = fopen (f, "r");
}


