/* -*-Mode:c++-*- */


//////////////////////////////////////////////////////////////////////////////
//
// NAME: Mitch Cherniack (mfc@cs.brown.edu)					 	 
// FILE: main.c
// PROJ: QLite -> KOLA Translator
// DATE: 7/98
//
//////////////////////////////////////////////////////////////////////////////

#include "KGlobals.H"

#include "QLParser.H"
#include "KOObject.H"
#include "KOBool.H"
#include "ENEnvironment.H"
#include "TYTUnk.H"
#include "TYTSet.H"
#include "TYTInt.H"
#include "TYTTup.H"
#include "QLAuxCode.H"

#include <iostream.h>
#include <fstream.h>

//////////////////////////////////////////////////////////////////////////////
//                                                                          
// Function Name:  main
// Parameters:	   int, char * []	
// Returns:
//
// Parses all query files provided as input:
//
//   e.g.  parse query1 query2 ... queryn
//
// printing out their resulting KOLA trees in succession.
//         								    
//////////////////////////////////////////////////////////////////////////////

main (int argc, char *argv[])  {

  char *rep;
  
  if (argc >= 1) {

	int c;
	char ch;
    
    int res = F;
    int mlrep = F;
    int type = F;
    int oql = F;
    int pretty = T;
    
    while (--argc > 0 && (*++argv) [0] == '-') {
      c = 1;
  	  ch = (*argv)[c];
  	  while (ch != '\0') {
  	    switch (ch) {
  	    case 'r':
		  res = T;
		  c++;
		  ch = (*argv)[c];
		  break;

	   case 'x':
		  mlrep = T;
                  c++;
                  ch = (*argv)[c];
		  break;

  	    case 's':
		  oql = T;
		  c++;
		  ch = (*argv)[c];
		  break;
  
  	    case 't':
		  type = T;
		  c++;
		  ch = (*argv)[c];
		  break;
  
  	    case 'm':
		  pretty = F;
		  c++;
		  ch = (*argv)[c];
		  break;
  
  	    default:
		  cout << "ql2kf: illegal option " << (char) c << endl;
		  argc = 0;
		  ch = '\0';
		  break;
  
  	    };
	  };
      };
      
	 if (argc == 0)
		cout << "Usage: ql2kf [-rmts] <Query File>" << endl;
	 else {
		while (*argv != 0) {
		  if (pretty) {
		    cout << "======================================================================" << endl;
		    cout << "Processing: " << *argv << endl << endl;
		  };
		  QLParser *p = new QLParser (*argv);
		  if (p == NULL)
		    cout << "Null Parser Object." << endl;
		  else {		    
		    NonType *k = p -> parse ();
		    if (k == NULL) {
		      cout << "Parse Failed" << endl;
		      delete k;
		    } else {
		      
		      if(mlrep) {
			rep = k -> representation ();
			cout<<"++++++++++++++++++++++++++\n\n";
			if (pretty)
			  cout<<"KOLA" << endl << "====" <<endl;
			cout<< rep << 	endl <<endl;
		      } else{
			rep =	 k -> representation ();
			if (res == T) {
			  if (pretty)
			    cout << "KOLA" << endl << "====" << endl;
			  cout << rep << endl << endl;
			};
		      }				  
		      delete [] rep;
		      delete k;			  
		    };
		    
		    if (oql == T) {
		      if (pretty)
			cout << "QLite" << endl << "=====" << endl;
		      ifstream f(*argv);
		      char c;
		      while (f.get(c)) cout << c;
		      cout << endl << endl;
		    };
		  };
		  delete p;
		  argv++;
		};
	 }
  } else
    cout << "Usage: ql2kf [-rxmts] <Query File>" << endl;
};








